/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/* Nome: USR_REGISTRA_FECHAMENTO.sql                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 25/01/2012 - Marcelo Alexsandro Souza Silva                                */
/******************************************************************************/

CREATE OR REPLACE TRIGGER USR_REGISTRA_FECHAMENTO
BEFORE UPDATE
ON PARAMFILIAL FOR EACH ROW
DECLARE
   V_CDFILIAL       VARCHAR2(4);
   V_COUNT          INTEGER;
   V_IDORIGREGISTRO VARCHAR2(1);
BEGIN
   IF :OLD.DTPROCESSA <> :NEW.DTPROCESSA THEN
      BEGIN
         SELECT COUNT(1)
           INTO V_COUNT
           FROM FILGRUPFILI
          WHERE CDFILIAL = :NEW.CDFILIAL
            AND CDGRUPFILI = '9999999999';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;

      IF V_COUNT > 0 THEN
         BEGIN
            SELECT USR_CDFILIAL, IDORIGREGISTRO
              INTO V_CDFILIAL, V_IDORIGREGISTRO
              FROM USR_FECHAMENTO
             WHERE USR_CDFILIAL = :NEW.CDFILIAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIAL       := NULL;
               V_IDORIGREGISTRO := NULL;
         END;

         IF (NVL(V_IDORIGREGISTRO, 'T') = 'T') THEN
            IF V_CDFILIAL IS NULL THEN
              INSERT INTO USR_FECHAMENTO
                (USR_CDFILIAL, USR_DTFECHADIA, USR_DTULTATUFECHA, DTANTFECHADIA, IDORIGREGISTRO, DTGRAVACAO, HRGRAVACAO, DTIMPORTACAO, HRIMPORTACAO)
              VALUES
                (:NEW.CDFILIAL, :NEW.DTPROCESSA, SYSDATE, :OLD.DTPROCESSA, 'T', TO_DATE(SYSDATE), TO_CHAR(SYSDATE, 'HH24MI'), NULL, NULL);
            ELSE
              UPDATE USR_FECHAMENTO
                 SET USR_DTFECHADIA    = :NEW.DTPROCESSA,
                     USR_DTULTATUFECHA = SYSDATE,
                     DTANTFECHADIA     = :OLD.DTPROCESSA,
                     IDORIGREGISTRO    = 'T',
                     DTGRAVACAO        = TO_DATE(SYSDATE),
                     HRGRAVACAO        = TO_CHAR(SYSDATE, 'HH24MI'),
                     DTIMPORTACAO      = NULL,
                     HRIMPORTACAO      = NULL
               WHERE USR_CDFILIAL = :NEW.CDFILIAL;
            END IF;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_REGISTRA_FECHAMENTO','5.09.xxx'); END;
/
