/* Tabela FRMTCOLLAY: TABELA DE FORMATAO DE COLUNA*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela FRMTCOLLAY */
/* Objetivo: Gerar um log que vai registrar as alteraes na FRMTCOLLAY,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_FRMTCOLLAY' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_FRMTCOLLAY
GO


CREATE TRIGGER LOG_VND_FRMTCOLLAY
ON FRMTCOLLAY
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_CDFRMTCOLLAY     VARCHAR(3);
  DECLARE @V_NEW_DSFRMTCOLLAY     VARCHAR(50);
  
  DECLARE @V_OLD_CDFRMTCOLLAY     VARCHAR(3);
  DECLARE @V_OLD_DSFRMTCOLLAY     VARCHAR(50);


BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           NULL,NULL,
	   DELETED.CDFRMTCOLLAY,
	   DELETED.DSFRMTCOLLAY
     FROM
           DELETED
     WHERE     
           DELETED.CDFRMTCOLLAY NOT IN (SELECT CDFRMTCOLLAY FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           INSERTED.CDFRMTCOLLAY,
           INSERTED.DSFRMTCOLLAY,
	   DELETED.CDFRMTCOLLAY,
	   DELETED.DSFRMTCOLLAY
     FROM
           INSERTED,
           DELETED
     WHERE     
          INSERTED.CDFRMTCOLLAY = DELETED.CDFRMTCOLLAY
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
           INSERTED.CDFRMTCOLLAY,
           INSERTED.DSFRMTCOLLAY,
           NULL,NULL            

     FROM
           INSERTED
     WHERE     
           INSERTED.CDFRMTCOLLAY NOT IN (SELECT CDFRMTCOLLAY FROM DELETED)

     OPEN C_CURSOR;
     FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
				   @V_NEW_CDFRMTCOLLAY,@V_NEW_DSFRMTCOLLAY,@V_OLD_CDFRMTCOLLAY,@V_OLD_DSFRMTCOLLAY

    WHILE (@@FETCH_STATUS = 0) BEGIN
    
       IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
		IF ISNULL(@V_NEW_CDFRMTCOLLAY,'NULL') <> ISNULL(@V_OLD_CDFRMTCOLLAY,'NULL') BEGIN
			SET @V_DESC  = 'Cd do Formato da Coluna ' + ISNULL(@V_NEW_CDFRMTCOLLAY,'' );
		END;
		IF ISNULL(@V_NEW_DSFRMTCOLLAY,'NULL') <> ISNULL(@V_OLD_DSFRMTCOLLAY,'NULL') BEGIN
			SET @V_DESC  = ISNULL(@V_DESC,'') + '  Formato do Campo no Layout ' + ISNULL(@V_NEW_DSFRMTCOLLAY,'' );
		END;
        SET @V_IDTIPOOPER = '2';
       END;
       IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
          SET @V_DESC  = 'Cd do Formato da Coluna  '   + ISNULL(@V_NEW_CDFRMTCOLLAY,'' )   + ' ' +
                  'Formato do Campo no Layout '        + ISNULL(@V_NEW_DSFRMTCOLLAY,'' );

          SET @V_IDTIPOOPER = '1';
       END;
       IF @V_ID_COMANDO= 'D' /*DELEO*/  BEGIN
          SET @V_DESC  = 'Cd do Formato da Coluna  '   + ISNULL(@V_OLD_CDFRMTCOLLAY,'' )   + ' ' +
                  'Formato do Campo no Layout '        + ISNULL(@V_OLD_DSFRMTCOLLAY,'' );

          SET @V_IDTIPOOPER = '3';
       END;
       IF  (@V_IDTIPOOPER <> '') BEGIN
          IF @V_DESC IS NOT NULL BEGIN
             SET @V_ITPESQ =  ISNULL( @V_NEW_CDFRMTCOLLAY + @V_NEW_DSFRMTCOLLAY,@V_OLD_CDFRMTCOLLAY + @V_OLD_DSFRMTCOLLAY);
             SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
             INSERT INTO LOGOPERAVND
                    (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                     CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                     CDORESPOPERVND)
             VALUES ('FRMTCOLLAY',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                     @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
          END;
       END;
       FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
				     @V_NEW_CDFRMTCOLLAY,@V_NEW_DSFRMTCOLLAY,@V_OLD_CDFRMTCOLLAY,@V_OLD_DSFRMTCOLLAY
    SET @V_DESC   = '';
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_FRMTCOLLAY','5.20.001';
GO
